Index: LMDZ5/branches/testing/libf/phylmd/surf_landice_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_landice_mod.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/surf_landice_mod.F90	(revision 2258)
@@ -17,5 +17,8 @@
        ps, u1, v1, rugoro, pctsrf, &
        snow, qsurf, qsol, agesno, &
-       tsoil, z0_new, alb1, alb2, evap, fluxsens, fluxlat, &
+!albedo SB >>>
+!      tsoil, z0_new, alb1, alb2, evap, fluxsens, fluxlat, &
+       tsoil, z0_new, SFRWL, alb_dir, alb_dif, evap, fluxsens, fluxlat, &
+!albedo SB <<<
        tsurf_new, dflux_s, dflux_l, &
        slope, cloudf, &
@@ -80,6 +83,10 @@
     REAL, DIMENSION(klon), INTENT(OUT)            :: qsurf
     REAL, DIMENSION(klon), INTENT(OUT)            :: z0_new
-    REAL, DIMENSION(klon), INTENT(OUT)            :: alb1  ! new albedo in visible SW interval
-    REAL, DIMENSION(klon), INTENT(OUT)            :: alb2  ! new albedo in near IR interval
+!albedo SB >>>
+!    REAL, DIMENSION(klon), INTENT(OUT)            :: alb1  ! new albedo in visible SW interval
+!    REAL, DIMENSION(klon), INTENT(OUT)            :: alb2  ! new albedo in near IR interval
+    REAL, DIMENSION(6), INTENT(IN)              ::SFRWL
+    REAL, DIMENSION(klon,nsw), INTENT(OUT)        ::alb_dir,alb_dif
+!albedo SB <<<
     REAL, DIMENSION(klon), INTENT(OUT)            :: evap, fluxsens, fluxlat
     REAL, DIMENSION(klon), INTENT(OUT)            :: tsurf_new
@@ -116,4 +123,8 @@
     CHARACTER (len = 20)                      :: modname = 'surf_landice'
     CHARACTER (len = 80)                      :: abort_message
+
+!albedo SB >>>
+    real,dimension(klon) :: alb1,alb2
+!albedo SB <<<
 
 ! End definition
@@ -315,4 +326,28 @@
 
 
+!albedo SB >>>
+     select case(NSW)
+     case(2)
+       alb_dir(1:knon,1)=alb1(1:knon)
+       alb_dir(1:knon,2)=alb2(1:knon)
+     case(4)
+       alb_dir(1:knon,1)=alb1(1:knon)
+       alb_dir(1:knon,2)=alb2(1:knon)
+       alb_dir(1:knon,3)=alb2(1:knon)
+       alb_dir(1:knon,4)=alb2(1:knon)
+     case(6)
+       alb_dir(1:knon,1)=alb1(1:knon)
+       alb_dir(1:knon,2)=alb1(1:knon)
+       alb_dir(1:knon,3)=alb1(1:knon)
+       alb_dir(1:knon,4)=alb2(1:knon)
+       alb_dir(1:knon,5)=alb2(1:knon)
+       alb_dir(1:knon,6)=alb2(1:knon)
+     end select
+alb_dif=alb_dir
+!albedo SB <<<
+
+
+
+
   END SUBROUTINE surf_landice
 !
Index: LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/surf_ocean_mod.F90	(revision 2258)
@@ -16,5 +16,8 @@
        ps, u1, v1, rugoro, pctsrf, &
        snow, qsurf, agesno, &
-       z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
+!albedo SB >>>
+!      z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
+       z0_new, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, & 
+!albedo SB <<<
        tsurf_new, dflux_s, dflux_l, lmt_bils, &
        flux_u1, flux_v1)
@@ -72,6 +75,10 @@
 !****************************************************************************************
     REAL, DIMENSION(klon), INTENT(OUT)       :: z0_new
-    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new  ! new albedo in visible SW interval
-    REAL, DIMENSION(klon), INTENT(OUT)       :: alb2_new  ! new albedo in near IR interval
+!albedo SB >>>
+!    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new  ! new albedo in visible SW interval
+!    REAL, DIMENSION(klon), INTENT(OUT)       :: alb2_new  ! new albedo in near IR interval
+    REAL, DIMENSION(6), INTENT(IN)          :: SFRWL 
+    REAL, DIMENSION(klon,nsw), INTENT(OUT)       :: alb_dir_new,alb_dif_new
+!albedo SB <<<     
     REAL, DIMENSION(klon), INTENT(OUT)       :: evap, fluxsens, fluxlat
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
@@ -82,5 +89,5 @@
 ! Local variables
 !****************************************************************************************
-    INTEGER               :: i
+    INTEGER               :: i, k
     REAL                  :: tmp
     REAL, PARAMETER       :: cepdu2=(0.1)**2
@@ -155,4 +162,10 @@
 !
 !****************************************************************************************
+!albedo SB >>>
+
+
+  if(iflag_albedo==1)then
+    call ocean_albedo(knon,rmu0,knindex,windsp,SFRWL,alb_dir_new,alb_dif_new)
+  else
     IF (cycle_diurne) THEN
        CALL alboc_cd(rmu0,alb_eau)
@@ -162,7 +175,12 @@
 
     DO i =1, knon
-       alb1_new(i) = alb_eau(knindex(i))
+      do  k=1,nsw
+       alb_dir_new(i,k) = alb_eau(knindex(i))
+      enddo
     ENDDO
-    alb2_new(1:knon) = alb1_new(1:knon)
+     alb_dif_new=0.05 !alb_dir_new
+endif
+
+!albedo SB <<<
 
 !****************************************************************************************
Index: LMDZ5/branches/testing/libf/phylmd/surf_seaice_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_seaice_mod.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/surf_seaice_mod.F90	(revision 2258)
@@ -1,2 +1,4 @@
+!
+! $Id$
 !
 MODULE surf_seaice_mod
@@ -17,5 +19,8 @@
        ps, u1, v1, rugoro, pctsrf, &
        snow, qsurf, qsol, agesno, tsoil, &
-       z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
+!albedo SB >>>
+!      z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
+       z0_new, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, &  
+!albedo SB <<<
        tsurf_new, dflux_s, dflux_l, &
        flux_u1, flux_v1)
@@ -34,4 +39,5 @@
 !
     INCLUDE "dimsoil.h"
+    INCLUDE "clesphys.h"
 
 ! Input arguments
@@ -67,6 +73,10 @@
 !****************************************************************************************
     REAL, DIMENSION(klon), INTENT(OUT)       :: z0_new
-    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new  ! new albedo in visible SW interval
-    REAL, DIMENSION(klon), INTENT(OUT)       :: alb2_new  ! new albedo in near IR interval
+!albedo SB >>>
+!    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new  ! new albedo in visible SW interval
+!    REAL, DIMENSION(klon), INTENT(OUT)       :: alb2_new  ! new albedo in near IR interval
+    REAL, DIMENSION(6), INTENT(IN)    :: SFRWL
+    REAL, DIMENSION(klon,nsw), INTENT(OUT)   :: alb_dir_new,alb_dif_new
+!albedo SB <<<
     REAL, DIMENSION(klon), INTENT(OUT)       :: evap, fluxsens, fluxlat
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
@@ -78,4 +88,7 @@
     REAL, DIMENSION(klon)  :: radsol
 
+!albedo SB >>>
+    REAL, DIMENSION(klon) :: alb1_new,alb2_new
+!albedo SB <<<
 !
 ! End definitions
@@ -140,4 +153,29 @@
     z0_new = SQRT(z0_new**2+rugoro**2)
 
+
+!albedo SB >>>
+     select case(NSW)
+     case(2)
+       alb_dir_new(1:knon,1)=alb1_new(1:knon)
+       alb_dir_new(1:knon,2)=alb2_new(1:knon)
+     case(4)
+       alb_dir_new(1:knon,1)=alb1_new(1:knon)
+       alb_dir_new(1:knon,2)=alb2_new(1:knon)
+       alb_dir_new(1:knon,3)=alb2_new(1:knon)
+       alb_dir_new(1:knon,4)=alb2_new(1:knon)
+     case(6)
+       alb_dir_new(1:knon,1)=alb1_new(1:knon)
+       alb_dir_new(1:knon,2)=alb1_new(1:knon)
+       alb_dir_new(1:knon,3)=alb1_new(1:knon)
+       alb_dir_new(1:knon,4)=alb2_new(1:knon)
+       alb_dir_new(1:knon,5)=alb2_new(1:knon)
+       alb_dir_new(1:knon,6)=alb2_new(1:knon)
+     end select
+alb_dif_new=alb_dir_new
+!albedo SB <<<
+
+
+
+
   END SUBROUTINE surf_seaice
 !
Index: LMDZ5/branches/testing/libf/phymar/iniphysiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phymar/iniphysiq.F90	(revision 2258)
+++ LMDZ5/branches/testing/libf/phymar/iniphysiq.F90	(revision 2258)
@@ -0,0 +1,157 @@
+!
+! $Id: iniphysiq.F 1403 2010-07-01 09:02:53Z fairhead $
+!
+SUBROUTINE iniphysiq(iim,jjm,nlayer,punjours, pdayref,ptimestep,         &
+                     rlatu,rlonv,aire,cu,cv,                             &
+                     prad,pg,pr,pcpp,iflag_phys)
+  USE dimphy, ONLY: klev ! number of atmospheric levels
+  USE mod_grid_phy_lmdz, ONLY: klon_glo ! number of atmospheric columns
+                                        ! (on full grid)
+  USE mod_phys_lmdz_para, ONLY: klon_omp, & ! number of columns (on local omp grid)
+                                klon_omp_begin, & ! start index of local omp subgrid
+                                klon_omp_end, & ! end index of local omp subgrid
+                                klon_mpi_begin ! start indes of columns (on local mpi grid)
+  USE comgeomphy, ONLY: initcomgeomphy, &
+                        airephy, & ! physics grid area (m2)
+                        cuphy, & ! cu coeff. (u_covariant = cu * u)
+                        cvphy, & ! cv coeff. (v_covariant = cv * v)
+                        rlond, & ! longitudes
+                        rlatd ! latitudes
+  USE comcstphy, ONLY: rradius, & ! planet radius (m)
+                       rr, & ! recuced gas constant: R/molar mass of atm
+                       rg, & ! gravity
+                       rcpp  ! specific heat of the atmosphere
+  USE phyaqua_mod, ONLY: iniaqua
+  IMPLICIT NONE
+  !
+  !=======================================================================
+  !   Initialisation of the physical constants and some positional and 
+  !   geometrical arrays for the physics
+  !=======================================================================
+ 
+ 
+  include "iniprint.h"
+
+  REAL,INTENT(IN) :: prad ! radius of the planet (m)
+  REAL,INTENT(IN) :: pg ! gravitational acceleration (m/s2)
+  REAL,INTENT(IN) :: pr ! ! reduced gas constant R/mu
+  REAL,INTENT(IN) :: pcpp ! specific heat Cp
+  REAL,INTENT(IN) :: punjours ! length (in s) of a standard day
+  INTEGER, INTENT (IN) :: nlayer ! number of atmospheric layers
+  INTEGER, INTENT (IN) :: iim ! number of atmospheric coulumns along longitudes
+  INTEGER, INTENT (IN) :: jjm  ! number of atompsheric columns along latitudes
+  REAL, INTENT (IN) :: rlatu(jjm+1) ! latitudes of the physics grid
+  REAL, INTENT (IN) :: rlonv(iim+1) ! longitudes of the physics grid
+  REAL, INTENT (IN) :: aire(iim+1,jjm+1) ! area of the dynamics grid (m2)
+  REAL, INTENT (IN) :: cu((iim+1)*(jjm+1)) ! cu coeff. (u_covariant = cu * u)
+  REAL, INTENT (IN) :: cv((iim+1)*jjm) ! cv coeff. (v_covariant = cv * v)
+  INTEGER, INTENT (IN) :: pdayref ! reference day of for the simulation
+  REAL,INTENT(IN) :: ptimestep !physics time step (s)
+  INTEGER,INTENT(IN) :: iflag_phys ! type of physics to be called
+
+  INTEGER :: ibegin,iend,offset
+  INTEGER :: i,j
+  CHARACTER (LEN=20) :: modname='iniphysiq'
+  CHARACTER (LEN=80) :: abort_message
+  REAL :: total_area_phy, total_area_dyn
+
+
+  ! global array, on full physics grid:
+  REAL,ALLOCATABLE :: latfi(:)
+  REAL,ALLOCATABLE :: lonfi(:)
+  REAL,ALLOCATABLE :: cufi(:)
+  REAL,ALLOCATABLE :: cvfi(:)
+  REAL,ALLOCATABLE :: airefi(:)
+ 
+  IF (nlayer.NE.klev) THEN
+    WRITE(lunout,*) 'STOP in ',trim(modname)
+    WRITE(lunout,*) 'Problem with dimensions :'
+    WRITE(lunout,*) 'nlayer     = ',nlayer
+    WRITE(lunout,*) 'klev   = ',klev
+    abort_message = ''
+    CALL abort_gcm (modname,abort_message,1)
+  ENDIF
+
+
+  ! Generate global arrays on full physics grid
+  ALLOCATE(latfi(klon_glo),lonfi(klon_glo),cufi(klon_glo),cvfi(klon_glo))
+  ALLOCATE(airefi(klon_glo))
+
+  IF (klon_glo>1) THEN ! general case
+    ! North pole
+    latfi(1)=rlatu(1)
+    lonfi(1)=0.
+    cufi(1) = cu(1)
+    cvfi(1) = cv(1)
+    DO j=2,jjm
+      DO i=1,iim
+        latfi((j-2)*iim+1+i)= rlatu(j)
+        lonfi((j-2)*iim+1+i)= rlonv(i)
+        cufi((j-2)*iim+1+i) = cu((j-1)*iim+1+i)
+        cvfi((j-2)*iim+1+i) = cv((j-1)*iim+1+i)
+      ENDDO
+    ENDDO
+    ! South pole
+    latfi(klon_glo)= rlatu(jjm+1)
+    lonfi(klon_glo)= 0.
+    cufi(klon_glo) = cu((iim+1)*jjm+1)
+    cvfi(klon_glo) = cv((iim+1)*jjm-iim)
+
+    ! build airefi(), mesh area on physics grid
+    CALL gr_dyn_fi(1,iim+1,jjm+1,klon_glo,aire,airefi)
+    ! Poles are single points on physics grid
+    airefi(1)=sum(aire(1:iim,1))
+    airefi(klon_glo)=sum(aire(1:iim,jjm+1))
+
+    ! Sanity check: do total planet area match between physics and dynamics?
+    total_area_dyn=sum(aire(1:iim,1:jjm+1))
+    total_area_phy=sum(airefi(1:klon_glo))
+    IF (total_area_dyn/=total_area_phy) THEN
+      WRITE (lunout, *) 'iniphysiq: planet total surface discrepancy !!!'
+      WRITE (lunout, *) '     in the dynamics total_area_dyn=', total_area_dyn
+      WRITE (lunout, *) '  but in the physics total_area_phy=', total_area_phy
+      IF (abs(total_area_dyn-total_area_phy)>0.00001*total_area_dyn) THEN
+        ! stop here if the relative difference is more than 0.001%
+        abort_message = 'planet total surface discrepancy'
+        CALL abort_gcm(modname, abort_message, 1)
+      ENDIF
+    ENDIF
+  ELSE ! klon_glo==1, running the 1D model
+    ! just copy over input values
+    latfi(1)=rlatu(1)
+    lonfi(1)=rlonv(1)
+    cufi(1)=cu(1)
+    cvfi(1)=cv(1)
+    airefi(1)=aire(1,1)
+  ENDIF ! of IF (klon_glo>1)
+
+!$OMP PARALLEL
+  ! Now generate local lon/lat/cu/cv/area arrays
+  CALL initcomgeomphy
+      
+  offset = klon_mpi_begin - 1
+  airephy(1:klon_omp) = airefi(offset+klon_omp_begin:offset+klon_omp_end)
+  cuphy(1:klon_omp) = cufi(offset+klon_omp_begin:offset+klon_omp_end)
+  cvphy(1:klon_omp) = cvfi(offset+klon_omp_begin:offset+klon_omp_end)
+  rlond(1:klon_omp) = lonfi(offset+klon_omp_begin:offset+klon_omp_end)
+  rlatd(1:klon_omp) = latfi(offset+klon_omp_begin:offset+klon_omp_end)
+
+! copy some fundamental parameters to physics
+  rradius=prad
+  rg=pg
+  rr=pr
+  rcpp=pcpp
+
+!$OMP END PARALLEL
+
+!      print*,'ATTENTION !!! TRAVAILLER SUR INIPHYSIQ'
+!      print*,'CONTROLE DES LATITUDES, LONGITUDES, PARAMETRES ...'
+
+! Additional initializations for aquaplanets 
+!$OMP PARALLEL
+      if (iflag_phys>=100) then
+        call iniaqua(klon_omp,rlatd,rlond,iflag_phys)
+      endif
+!$OMP END PARALLEL
+
+      END
Index: LMDZ5/branches/testing/libf/phymar/physiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phymar/physiq.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phymar/physiq.F90	(revision 2258)
@@ -10,5 +10,5 @@
       SUBROUTINE physiq (nlon,nlev, &
      &            debut,lafin,jD_cur, jH_cur,pdtphys, &
-     &            paprs,pplay,pphi,pphis,ppresnivs,clesphy0, &
+     &            paprs,pplay,pphi,pphis,ppresnivs, &
      &            u,v,t,qx, &
      &            flxmass_w, &
@@ -118,6 +118,4 @@
       real,intent(in) :: pphis(klon) ! surface geopotential
       real,intent(in) :: ppresnivs(klev) ! pseudo-pressure (Pa) of mid-layers
-      integer,parameter :: longcles=20
-      real,intent(in) :: clesphy0(longcles) ! Not used
       real,intent(in) :: u(klon,klev) ! eastward zonal wind (m/s)
       real,intent(in) :: v(klon,klev) ! northward meridional wind (m/s)
